var Collection = require('mongodb').Collection,
Cursor = require('mongodb').Cursor,
Guava = require('guava').Client;

Collection.prototype.guava = function()
{
	return Guava.collection(this.collectionName);
}

Collection.prototype.bind = function(query, callback)
{
	console.log(this.collectionName);

	this.guava().on(query, callback);
}

var oldInsert = Collection.prototype.insert;

Collection.prototype.insert = function(doc, options, callback)
{
	if ('function' === typeof options) callback = options, options = {};
  	if(options == null) options = {};
	if(!('function' === typeof callback)) callback = null;

	var self = this;

	var onInsert = function(err, items)
	{
		if(callback) callback.apply(null, arguments);

		for(var i = items.length; i--;)
		{
			self.guava().emit(items[i]);
		}
	}

	oldInsert.call(this, doc, options, onInsert);
}


Cursor.prototype.bind = function(callback)
{
	return this.collection.bind(this.selector, callback);
}